//+------------------------------------------------------------------+
//|                                                     .mq4 |
//|                                              Skvorsov Konstantin |
//|                                                    skvkv@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Skvorsov Konstantin"
#property link      "skvkv@mail.ru"

#include <b-Lots.mqh>
extern double TrailingStop = 20;//      
extern double X=2;//  + 5 ! 
extern double Chperiod = 7;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double S_g1,S_g2,S_r1,S_r2,T_g1,T_r1,T_g2,T_r2,PFE1,PFE2;
   double P_up0,P_down0,P_up1,P_down1;
   int cnt,ticket,total,i;
   bool flag=true;

   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
     //    
   
   cnt=OrdersHistoryTotal()-1;
   for(i=cnt;i>=0;i--) {
      if(!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY )) continue;
      if(OrderOpenTime()>=Time[0]) { // Time[0] -        
         flag=false;
         break;
      }
   }
   cnt=OrdersTotal()-1;
   for(i=cnt;i>=0;i--) {
      if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderOpenTime()>=Time[0]) { // Time[0] -        
         flag=false;
         break;
      }
   }
   P_up0=iCustom(0,0," ",Chperiod,0,0);
   P_down0=iCustom(0,0," ",Chperiod,1,0);
   P_up1=iCustom(0,0," ",Chperiod,0,1);
   P_down1=iCustom(0,0," ",Chperiod,1,1);
   S_g1=iCustom(0,0,"",14,false,14,14,14,14,14,14,14,14,14,0,1);
   S_g2=iCustom(0,0,"",14,false,14,14,14,14,14,14,14,14,14,0,2);
   S_r1=iCustom(0,0,"",14,false,14,14,14,14,14,14,14,14,14,1,1);
   S_r2=iCustom(0,0,"",14,false,14,14,14,14,14,14,14,14,14,1,2);
   T_g1=iCustom(0,0,"Trend",0,0,0,21,2,2,9300,0,1);
   T_r1=iCustom(0,0,"Trend",0,0,0,21,2,2,9300,1,1);
   T_g2=iCustom(0,0,"Trend",0,0,0,20,2,13,9300,0,2);
   T_r2=iCustom(0,0,"Trend",0,0,0,20,2,13,9300,1,2);
   PFE1=iCustom(0,0,"PFE",5,true,5,0,1);
   PFE2=iCustom(0,0,"PFE",5,true,5,0,2);
//   

   total=OrdersTotal();
   if(total<1) 
     {
      //   
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      //    BUY
      if(T_g1>T_r1&&T_g1>0&&PFE2<PFE1&&PFE1>0&&PFE2<0)
        {
      if((total>0) || (!flag)) return(0);
      Lots=GetSizeLot();
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"",0,0,Green);
      if(ticket>0) {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            Alert(": ",OrderOpenPrice()); 
      }  else Alert(":  ",OrderOpenPrice()); 
      return(0); 
   }
      //    SELL
      if(T_g1<T_r1&&T_g1<0&&PFE2>PFE1&&PFE1<0&&PFE2>0)
        {
      if((total>0) || (!flag)) return(0);
      Lots=GetSizeLot();
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"",0,0,Red);
      if(ticket>0) {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            Alert(": ",OrderOpenPrice()); 
      }  else Alert(":  ",OrderOpenPrice()); 
      return(0); 
   }
    
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   
         OrderSymbol()==Symbol())  
        {
         if(OrderType()==OP_BUY)   //   
           {
            //    
            if(P_down1>P_down0)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); 
                 return(0); 
                }
            if(TrailingStop>0)  
              {                  
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop && OrderStopLoss()!=OrderOpenPrice()+X*Point)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+X*Point,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else 
           {
            //    
            if(P_up1<P_up0)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); 
               return(0); 
              }
              
            if(TrailingStop>0)  
              {               
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if(NormalizeDouble(OrderStopLoss(),Digits) != NormalizeDouble(OrderOpenPrice()-X*Point,Digits))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-X*Point,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
           
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+